UNIT full_edi;
{$O+,F+}
interface
USES {$IFDEF msdos} OVERLAY,{$ENDIF} CRT,util,dir;
PROCEDURE editor(VAR stri; maxz:INTEGER; VAR nz:INTEGER);
IMPLEMENTATION


{ Version vom 3.3.91
Editor hat im Moment folgende Funktionen:

F2       Speichern
F3       Laden
F9       Quit
F10      Save and Quit
^S       Suchen
^E       Ersetzen
^L       Nocheinmal Suchen oder Ersetzen (je nachdem, was als letztes gemacht wurde)
home     Anfang Zeile
end      Ende Zeile
Pg down  Seite abwrts
Pg up    Seite aufwrts
^Pg down File Ende
^Pg up   File Anfang
^Y       Zeile Lschen
INS      gelschte Zeile von aktueller Zeile einfgen
}

PROCEDURE editor(VAR stri; maxz:INTEGER; VAR nz:INTEGER);
VAR z_:ARRAY [1..640] OF STRING[80] ABSOLUTE stri;
    ver,bs,be,offset,i,taste:INTEGER;
    curs,curz:WORD;
    undo_,opt_,such_,ersetz_,path_,fname_,dummy_:STRING[80];
    ers:BOOLEAN;
    fp:TEXT;

CONST scroll=10;
      bildschirm=24;
LABEL 1;
      {-----------------------------------------------------------------------------}
PROCEDURE darstell;
VAR i:INTEGER;
BEGIN
  i:=1; CLRSCR;
  WHILE (i<=bildschirm) AND (i+offset<=nz) DO
  BEGIN
    GOTOXY(1,i); WRITE(z_[i+offset]);
    INC(i);
  END;
END;
{-----------------------------------------------------------------------------}
PROCEDURE einfuege(n:INTEGER);
VAR i:INTEGER;
BEGIN
  FOR i:=nz+1 DOWNTO n+1 DO z_[i]:=z_[i-1];
  z_[n]:=''; nz:=mini(nz+1,maxz);
END;
{-----------------------------------------------------------------------------}
PROCEDURE loesche(n:INTEGER);
VAR i:INTEGER;
BEGIN
  FOR i:=n TO nz-1 DO z_[i]:=z_[i+1]; DEC(nz);
END;
{-----------------------------------------------------------------------------}
PROCEDURE einlesen(VAR fname_:STRIN; aus_:STRIN);
VAR curs:WORD;
BEGIN
  GOTOXY(1,2); CLREOL; GOTOXY(1,3); CLREOL; GOTOXY(1,1); CLREOL; fname_:='';
  WRITELN('File '+aus_);
  curs:=LENGTH(rtrim(ltrim(path_)))+1;
  REPEAT
    GOTOXY(1,2); WRITE(path_); GOTOXY(curs,2); taste:=tastatur;
    editk(taste,curs,1,78,path_,TRUE);
  UNTIL (taste=13) OR (taste=27);
  IF taste=13 THEN IF (POS('?',path_)<>0) OR (POS('*',path_)<>0) THEN
  BEGIN
    CLRSCR; directory(path_,fname_); CLRSCR;
  END ELSE fname_:=path_;
END;
{-----------------------------------------------------------------------------}
FUNCTION einlese_such(titel_:STRIN; VAR such_:STRIN):INTEGER;
VAR curs:WORD;
BEGIN
  curs:=LENGTH(rtrim(such_))+1;
  GOTOXY(1,1); WRITE('Eingabe '+titel_); CLREOL; such_:=laenge(such_,80,' ');
  GOTOXY(1,2); WRITE(such_);
  REPEAT
    GOTOXY(1,2); WRITE(such_); GOTOXY(curs,2); taste:=tastatur;
    editk(taste,curs,1,78,such_,TRUE);
  UNTIL (taste=13) OR (taste=27);
  such_:=rtrim(such_); einlese_such:=taste;
END;
{-----------------------------------------------------------------------------}
PROCEDURE speichern(fname_:STRIN);
VAR i:INTEGER;
BEGIN
  ASSIGNFILE(fp,fname_); REWRITE(fp); z_[curz]:=rtrim(dummy_);
  FOR i:=1 TO nz DO WRITELN(fp,z_[i]);
  CLOSEFILE(fp);
END;
{-----------------------------------------------------------------------------}
PROCEDURE laden(fname_:STRIN);
BEGIN
  ASSIGNFILE(fp,fname_); RESET(fp); i:=0;
  WHILE (NOT EOF(fp)) AND (i<maxz) DO
  BEGIN
    INC(i); READLN(fp,z_[i]);
  END;
  CLOSEFILE(fp);
  nz:=maxi(1,i); offset:=0; curs:=1; curz:=1; dummy_:=laenge(z_[1],80,' ');
END;
{-----------------------------------------------------------------------------}
FUNCTION suche(s_:STRIN; spalte,z:INTEGER):BOOLEAN;
VAR a:INTEGER;
    gefunden:BOOLEAN;
BEGIN
  z_[curz]:=rtrim(dummy_); gefunden:=FALSE;
  REPEAT
    a:=POS(s_,COPY(z_[z],spalte,255));
    IF a<>0 THEN
    BEGIN
      gefunden:=TRUE;
    END ELSE
    BEGIN
      INC(z); spalte:=1;
    END;
  UNTIL gefunden OR (z>nz);
  IF gefunden THEN
  BEGIN
    curz:=z; curs:=a+spalte+LENGTH(s_)-1;
    dummy_:=laenge(z_[curz],80,' ');
  END;
  WHILE curz-offset>bildschirm DO INC(offset,bildschirm);
  WHILE offset>curz DO DEC(offset,bildschirm);
  IF ers AND (POS('H',opt_)=0) THEN
  BEGIN
    darstell; GOTOXY(curs,curz-offset);
  END;
  suche:=gefunden;
END;
{-----------------------------------------------------------------------------}
PROCEDURE ersetze;
VAR i:INTEGER;
LABEL wieder;

PROCEDURE tu_es;
BEGIN
  z_[curz]:=COPY(z_[curz],1,curs-LENGTH(such_)-1)+ersetz_+COPY(z_[curz],curs,255);
  INC(curs,LENGTH(ersetz_)-LENGTH(such_)); GOTOXY(1,WHEREY); WRITE(z_[curz]);
  dummy_:=laenge(z_[curz],80,' ');
  GOTOXY(curs,WHEREY);
END;
{-----------------------------------------------------------------------------}
BEGIN
  IF POS('C',opt_)=0 THEN
  BEGIN
    z_[curz]:=rtrim(dummy_); curz:=1; curs:=1; dummy_:=laenge(z_[curz],80,' ');
  END;
  wieder:
  IF KEYPRESSED THEN
  IF READKEY=#27 THEN
  BEGIN
    darstell; EXIT;
  END;
  IF suche(such_,curs,curz) THEN
  BEGIN
    IF POS('F',opt_)<>0 THEN
    BEGIN
      GOTOXY(20,25); WRITE('Y/N'); GOTOXY(curs,curz-offset);
      i:=tastatur; GOTOXY(1,25); CLREOL;
      IF (i=89) OR (i=121) THEN tu_es;
    END ELSE tu_es;
    IF POS('A',opt_)<>0 THEN GOTO wieder;
  END;
END;
{-----------------------------------------------------------------------------}
BEGIN
  dummy_:=laenge(z_[1],80,' '); curs:=1; curz:=1; offset:=0; darstell; bs:=1; be:=0;
  path_:='*.*'; such_:=''; ersetz_:=''; ers:=FALSE; opt_:=''; undo_:='';
  REPEAT
    GOTOXY(1,curz-offset); WRITE(dummy_); GOTOXY(1,25);
    WRITE('zeile=',curz:4,' spalte=',curs:2,'           F2 Speichern  F3 Laden  F9 Quit  F10 Save & Quit');
    GOTOXY(curs,curz-offset); taste:=tastatur;
    1:
    CASE taste OF
      12: { ^L wieder suchen }
      IF such_<>'' THEN
      BEGIN
        IF ers THEN
        BEGIN
          ersetze;
          IF POS('H',opt_)<>0 THEN darstell;
        END
        ELSE IF suche(such_,curs,curz) THEN;
      END;
      19: { ^S }
      BEGIN
        IF einlese_such('Suchstring',such_)=13 THEN
        BEGIN
          ers:=FALSE; IF suche(such_,curs,curz) THEN;
        END;
        darstell;
      END;
      5: { ^E }
      BEGIN
        IF (einlese_such('Suchstring',such_)=13) AND (such_<>'') THEN
        BEGIN
          IF einlese_such('Ersatzstring',ersetz_)=13 THEN
          BEGIN
            IF einlese_such('Option',opt_)=13 THEN;
            ers:=TRUE; opt_:=ucase(opt_);
            ersetze;
            IF POS('H',opt_)<>0 THEN darstell;
          END;
        END;
        darstell;
      END;
      316: { F2  speichern }
      BEGIN
        einlesen(fname_,'speichern');
        IF fname_<>'' THEN speichern(fname_);
        darstell;
      END;
      317: { F3 laden }
      BEGIN
        einlesen(fname_,'laden');
        IF fname_<>'' THEN laden(fname_);
        darstell;
      END;
      13: { RETURN }
      BEGIN
        dummy_:=rtrim(dummy_); einfuege(curz+1);
        z_[curz+1]:=COPY(dummy_,curs,80); dummy_:=COPY(dummy_,1,curs-1);
        z_[curz]:=dummy_; darstell; curs:=1;
        taste:=336; GOTO 1;
      END;
      8: { BS }
      BEGIN
        IF curs=1 THEN
        BEGIN
          IF curz>1 THEN
          BEGIN
            IF LENGTH(rtrim(dummy_))+LENGTH(rtrim(z_[curz-1]))<80 THEN
            BEGIN
              DEC(curz); curs:=LENGTH(rtrim(z_[curz]))+1;
              dummy_:=laenge(rtrim(z_[curz])+rtrim(dummy_),80,' ');
              loesche(curz+1); darstell;
            END;
          END;
        END
        ELSE editk(8,curs,1,78,dummy_,TRUE);
      END;
      25: { ^Y }
      BEGIN
        undo_:=z_[curz];
        loesche(curz); curs:=1; darstell; dummy_:=laenge(z_[curz],80,' ');
      END;
      338: { Ins }
      BEGIN
        z_[curz]:=rtrim(dummy_); einfuege(curz); z_[curz]:=undo_;
        dummy_:=undo_; darstell;
      END;
      339: { del }
      BEGIN
        IF LENGTH(rtrim(dummy_))+1=curs THEN
        BEGIN
          IF nz>1 THEN IF LENGTH(rtrim(dummy_))+LENGTH(rtrim(z_[curz+1]))<80 THEN
          BEGIN
            dummy_:=laenge(rtrim(dummy_)+rtrim(z_[curz+1]),80,' ');
            loesche(curz+1); darstell;
          END;
        END
        ELSE editk(339,curs,1,78,dummy_,TRUE);
      END;
      328: { cursor oben   }
      IF curz>1 THEN
      BEGIN
        z_[curz]:=rtrim(dummy_); DEC(curz); dummy_:=laenge(z_[curz],80,' ');
        IF curz-offset<1 THEN
        BEGIN
          ver:=mini(scroll,curz); DEC(offset,ver); darstell;
        END;
      END;
      329: { pg up   }
      IF offset>=bildschirm THEN
      BEGIN
        z_[curz]:=rtrim(dummy_); DEC(curz,bildschirm); dummy_:=laenge(z_[curz],80,' ');
        DEC(offset,bildschirm); darstell
      END
      ELSE
      BEGIN
        z_[curz]:=rtrim(dummy_); curz:=1; offset:=0; curs:=1; dummy_:=laenge(z_[curz],80,' ');
        darstell;
      END;
      388: { ^Pgup }
      BEGIN
        z_[curz]:=rtrim(dummy_); curz:=1; offset:=0; curs:=1; dummy_:=laenge(z_[curz],80,' ');
        darstell;
      END;
      337: { pg down   }
      IF curz<=nz-bildschirm THEN
      BEGIN
        z_[curz]:=rtrim(dummy_); INC(curz,bildschirm); dummy_:=laenge(z_[curz],80,' ');
        INC(offset,bildschirm); darstell
      END
      ELSE
      BEGIN
        z_[curz]:=rtrim(dummy_); curz:=nz; curs:=1; dummy_:=laenge(z_[curz],80,' ');
        darstell;
      END;
      374: { ^Pgdn }
      BEGIN
        z_[curz]:=rtrim(dummy_); curz:=nz; curs:=1; dummy_:=laenge(z_[curz],80,' ');
        darstell; WHILE curz-offset>bildschirm DO INC(offset); darstell;
      END;
      336: { cursor unten }
      IF curz<nz THEN
      BEGIN
        z_[curz]:=rtrim(dummy_); INC(curz); dummy_:=laenge(z_[curz],80,' ');
        IF curz-offset>bildschirm THEN
        BEGIN
          INC(offset,scroll); darstell;
        END;
      END;
      323: { F9 } EXIT;
      324: { F10 }
      BEGIN
        z_[curz]:=dummy_; speichern(fname_);
        EXIT;
      END
      ELSE editk(taste,curs,1,78,dummy_,TRUE);
    END;
  UNTIL FALSE;
END;
{-----------------------------------------------------------------------------}
END.
