UNIT tty;
INTERFACE
USES {$IFNDEF win32} CRT, {$ENDIF}
     util;
CONST {$IFDEF win32}
        max_zeilen=600; { diese Deklaration sonst in Fulledit }
        maxsize  =10000000; { this time }
        maxcolumn=10000000;
        maxrow   =maxcolumn;
      {$ELSE}
        maxsize=2 SHL 15-20;
        maxcolumn=16000;
        maxrow=8000;
      {$ENDIF}
      {version_='3.3 vom 27.6.2004';}
      {version_='3.40 vom 10.10.2004';} { adding Memory manager recyclermm}
      version_='3.41 vom 10.10.2004'; { Load Basis before load tree }
      max_length=25;
      min_nodes           =5;
      pseu_init           =1E10;
      pseu_inf            =1E14;
      up_bound_lmt        =1E21;
      inkrem              =5;
      row_lmax    :INTEGER=0;
      col_lmax    :INTEGER=0;
      tol100      :DOUBLE =1E-09;   { tolerance for violation of bounds }
      tolerance           =1E-11;
      tol_etha            =1E-13;
      titel_='    DJ     Vector_in  Vector_out     OBJF       INFEASIBILITY      nit   Time  ninv';
      nzehn=10;
      max_sos2=100;
      hash_mult:ARRAY [1..25] OF INTEGER=( 8741, 8837, 8941, 9041, 9151, 9239, 9341, 9431, 9511, 9629,
                                           9733, 9817, 9907,10039,10139,10243,10321,10433,10531,10651,
                                          10739,10861,10973,11083,11173);

TYPE stack_row=RECORD
                 ch,neu:INTEGER;
                 old:DOUBLE;
                 bo:BOOLEAN;
               END;
     buffer=ARRAY [1..14000] OF LONGINT;
CONST maxbound=64000 DIV SIZEOF(stack_row);

      nhist=50;
TYPE {$IFDEF EXTENDED}
     DOUBLE=EXTENDED;
     {$ENDIF}
     thist=OBJECT
             hist_list:ARRAY [0..nhist-1] OF RECORD
                                               oobjf,iinf:DOUBLE;
                                               vec_out_:string[30];
                                               noft:INTEGER;
                                             END;
             CONSTRUCTOR init(nit:LONGINT; inf,objf:DOUBLE; v_:STRING);
             DESTRUCTOR done;
           END;

     koo=RECORD x,y:INTEGER; END;
     string80=STRING[80];
     string_type=STRING[max_length];
     string_type_feld=ARRAY [1..1000] OF string_type;
     pstring_type_feld=^string_type_feld;

     waag=RECORD
            z:INTEGER; wert:DOUBLE;
          END;
     zwaag=RECORD
             sp,z:INTEGER; wert:DOUBLE;
           END;
     down=ARRAY [1..maxsize DIV SIZEOF(waag)] OF waag;
     down_pointer=^down;
     tladder=OBJECT
              cm:down_pointer;
              coben:INTEGER;
              PROCEDURE   longer(number:LONGINT);
              CONSTRUCTOR init  (number:LONGINT);
              DESTRUCTOR  done;
            END;
     etha_ladder=ARRAY [1..maxsize DIV SIZEOF(tladder)] OF tladder;
     tet=OBJECT
           etha:^etha_ladder;
           netha:INTEGER;
           PROCEDURE   clear_etha(n:INTEGER; VAR nelemen:LONGINT);
           CONSTRUCTOR init(n:INTEGER);
           DESTRUCTOR  done;
         END;
     tetha=OBJECT(tet)
             maxetha:INTEGER;
             nelemen,ethaspace:LONGINT;
             CONSTRUCTOR init(n:INTEGER);
             DESTRUCTOR  done;
           END;
     zabwaerts=ARRAY [1..maxsize DIV SIZEOF(zwaag)] OF zwaag;
     zabwaerts_pointer=^zabwaerts;
     pointer_feld=ARRAY [1..maxcolumn] OF ^INTEGER;
     pointer_feld_pointer=^pointer_Feld;
     int_feld=ARRAY [1..maxcolumn] OF INTEGER;
     pint_feld=^int_feld;
     feld=ARRAY [1..maxrow] OF DOUBLE;
     tfeld=OBJECT
             feld_pointer:^feld;
             PROCEDURE   clear(n:INTEGER);
             CONSTRUCTOR init (n:INTEGER);
             DESTRUCTOR  done (n:INTEGER);
           END;
     hash_feld=ARRAY [0..2*maxcolumn] OF INTEGER;
     phash_feld=^hash_feld;
     thash=OBJECT
             hash:phash_feld;
             hash_alloc:INTEGER;
             FUNCTION    gethash(VAR s_:STRIN):LONGINT;
             PROCEDURE   clearhash;
             CONSTRUCTOR init(alloc:INTEGER);
             DESTRUCTOR  done;
           END;
     tcolumn=OBJECT(tladder)
               cha,canzahl:WORD;
               spa_:string_type;
               lo_bound,up_bound,cost,float,dj:DOUBLE;
               p_plus,p_minus,int_value,int_dj:SINGLE;
               inttype,on_upper,art:SHORTINT;
               allowed:BOOLEAN;
               CONSTRUCTOR init(name_:STRING_type; kind:SHORTINT);
               DESTRUCTOR  done;
             END;
     ptcolumn=^tcolumn;
     tcolumn_array=ARRAY [-1..maxcolumn] OF ptcolumn;
     tpcolumn_array=^tcolumn_array;
     tcolumns=OBJECT
                co_hash:thash;
                col_alloc,nvar:INTEGER;
                co:tpcolumn_array;
                PROCEDURE   put_col_hash;
                PROCEDURE   re_alloc_columns;
                PROCEDURE   qsort_dj(li,re:INTEGER);
                PROCEDURE   swap_columns(i1,i2:INTEGER);
                PROCEDURE   eliminate_column(i:INTEGER);
                FUNCTION    get_range(row:INTEGER):DOUBLE;
                FUNCTION    get_entry(row,column:INTEGER):DOUBLE;
                FUNCTION    search_column(s_:STRIN; kind:SHORTINT):INTEGER;

                FUNCTION    get_optimal_value(col_:STRIN):DOUBLE;
                FUNCTION    get_optimal_dj(col_:STRIN):DOUBLE;
                FUNCTION    get_optimal_int_value(col_:STRIN):SINGLE;
                FUNCTION    get_optimal_int_dj(col_:STRIN):SINGLE;

                FUNCTION    get_optimal_row_value(col_:STRIN):DOUBLE;
                FUNCTION    get_optimal_row_dj(col_:STRIN):DOUBLE;
                FUNCTION    get_optimal_row_int_value(col_:STRIN):SINGLE;
                FUNCTION    get_optimal_row_int_dj(col_:STRIN):SINGLE;
                CONSTRUCTOR init;
                DESTRUCTOR  done;
              END;
     trow=OBJECT
             row_:string_type;
             gleich:SHORTINT;
             { rnum, }
             roben1_alt,roben_alt,reoben,roben,
             rhas,reanzahl,ranzahl,ranzahl1:WORD;
             rm:zabwaerts_pointer;
             rem,rm1:pointer_feld_pointer;
             rl:pint_feld;
             CONSTRUCTOR init(c:CHAR; s_:STRING; h:INTEGER);
             DESTRUCTOR  done;
           END;
     ptrow=^trow;
     trow_array=ARRAY [1..maxcolumn] OF ptrow;
     tprow_array=^trow_array;
     trows=OBJECT
             row_alloc,nrows:INTEGER;
             ro_hash:thash;
             ro:tprow_array;
             FUNCTION    search_row(s_:STRIN):INTEGER;
             CONSTRUCTOR init;
             DESTRUCTOR  done;
           END;
     stack_row_array=ARRAY [1..maxbound] OF stack_row;
     stack_row_array_pointer=^stack_row_array;
     tbasis=RECORD
              nin:LONGINT;
              let_in,net,ubas:INTEGER;
              bas:pINT_feld;
            END;
     stack_type=RECORD
                  non_int,nz:INTEGER;
                  we,ob:DOUBLE;
                  b:tbasis;
                  zp:pINT_feld;
                END;
     stack_type_pointer=^stack_type;
     wstack_pointer=^wstack;
     wstack=RECORD
              next,prev:wstack_pointer;
              st:stack_type;
            END;
     datei_row_pointer=^datei_row;
     datei_row=RECORD
                   next,prev:datei_row_pointer;
                   o:DOUBLE;
                   basis_start:LONGINT;
                 END;
     datei_record=RECORD
                    noni,ninn:LONGINT;
                    nzz,let_inn,nett,ubass:INTEGER;
                    wee:DOUBLE;
                  END;
     tsos2_row=OBJECT
                 nsos2_elements_max,nsos2_elements:INTEGER;
                 sos2_name_:string_type;
                 sos2_:pstring_type_feld;
                 CONSTRUCTOR init(so_:STRING);
                 DESTRUCTOR  done;
                 PROCEDURE   add(s_:STRING);
               END;
     tsos2_obj=OBJECT
                 nsos2:INTEGER;
                 sos2:ARRAY [1..max_sos2] OF ^tsos2_row;
                 CONSTRUCTOR init;
                 DESTRUCTOR  done;
                 PROCEDURE   define_sos2(so_,col_:STRING);
               END;

CONST maxtiefe   =maxsize DIV SIZEOF(POINTER);
      feld_breite=SIZEOF(datei_record) DIV SIZEOF(INTEGER);

TYPE stapel=ARRAY [1..maxtiefe] OF stack_type_pointer;
     stapel_pointer=^stapel;

CONST { Coordinates for screen output in DOS-Mode }
      koosum         :koo=(x: 0; y:0); { dummy }
      koohead        :koo=(x: 0; y:1); { dummy }
      koomema        :koo=(x:63; y:1);
      koomaxa        :koo=(x:73; y:1);
      koominpiv      :koo=(x:63; y:2);
      koonne         :koo=(x:75; y:2);
      kooninf        :koo=(x: 1; y:3);
      koosavenodes   :koo=(x:17; y:3);
      koonodes       :koo=(x:38; y:3);
      koowtiefe      :koo=(x:49; y:3);
      koohitnodes    :koo=(x:60; y:3);
      koototnodes    :koo=(x:72; y:3);
      koointstatus   :koo=(x: 1; y:4);
      koongleich     :koo=(x:40; y:4);
      koobounds      :koo=(x:41; y:4);
      koominnz       :koo=(x:50; y:4);
      kooneeu        :koo=(x:59; y:4);
      koonbounds     :koo=(x:75; y:4);
      koointfound    :koo=(x:65; y:5);
      koo7           :koo=(x: 7; y:7); { dummy for win32 }

TYPE bound_feld=ARRAY [0..maxbound] OF stack_row;
     bound_type=ARRAY [0..10] OF ^bound_feld;
     tbound=OBJECT
              bounds:ARRAY [0..10] OF ^bound_feld;
              nboundfeld,nbounds:INTEGER;
              FUNCTION    search_bound(VAR sr:stack_row):INTEGER;
              FUNCTION    save_bounds(fname_:STRIN):INTEGER;
              PROCEDURE   get_bound(i:INTEGER; VAR sr:stack_row);
              FUNCTION    add(VAR sr:stack_row):INTEGER;
              PROCEDURE   read_bounds(nbo:INTEGER; fname_:STRIN);
              CONSTRUCTOR init;
              DESTRUCTOR  done;
            END;
     tint_datei=RECORD
                  basis_length,ndatei:LONGINT;
                  datei_root,datei_end:datei_row_pointer;
                  saved,exist,open:BOOLEAN;
                  fp_basis:FILE;
                END;
     tint_rec=OBJECT(tbound)
                wtiefe:LONGINT;
                min_nodes,neeu,obenstack,ngleich,tiefe:INTEGER;
                nexx,vat,vaterob,upper_limit,lower_limit:DOUBLE;
                lasthit,nodes_cut,node,max_memory:LONGINT;
                weight:SINGLE;
                cut,assess,integer_found:BOOLEAN;
                CONSTRUCTOR init;
                DESTRUCTOR  done;
              END;
     sc=OBJECT
          with_output:BOOLEAN;
          sc_:STRIN;
          FUNCTION  keypressed:BOOLEAN;
          FUNCTION  readkey:CHAR;
          FUNCTION  wherex:INTEGER;
          FUNCTION  wherey:INTEGER;
          PROCEDURE delay(ms:LONGINT);
          PROCEDURE int_start;
          PROCEDURE noise;
          PROCEDURE add_eps(n:INTEGER);
          PROCEDURE remove_eps;
          PROCEDURE WRITELN(s_:STRIN);
          PROCEDURE WRITE(s_:STRIN);
          PROCEDURE GOTOXY(x,y:INTEGER);
          PROCEDURE window(x1,x2,x3,x4:INTEGER);
          PROCEDURE clrscr;
          PROCEDURE set_output(s:BOOLEAN);
          PROCEDURE textcolor(c:INTEGER);
          PROCEDURE textbackground(c:INTEGER);
          PROCEDURE win_out(k:koo; s_:STRIN);
          PROCEDURE inversion(s_:STRIN);
          PROCEDURE inf_2;
          CONSTRUCTOR init;
          DESTRUCTOR  done;
        END;

VAR scr:sc;

IMPLEMENTATION

{$IFDEF win32} uses sysutils,forms,lp_form; {$ENDIF}

CONSTRUCTOR thist.init(nit:LONGINT; inf,objf:DOUBLE; v_:STRING);
BEGIN
  WITH hist_list[nit MOD nhist] DO
  BEGIN
    oobjf:=objf; iinf:=inf; vec_out_:=v_;
  END;
END;
{----------------------------------------------------------------------------}
DESTRUCTOR thist.done;
BEGIN
END;
{----------------------------------------------------------------------------}
DESTRUCTOR tfeld.done;
BEGIN
  IF feld_pointer<>NIL THEN FREEMEM(feld_pointer,LONGINT(n)*SIZEOF(DOUBLE));
  feld_pointer:=NIL;
END;
{---------------------------------------------------------------------------}
PROCEDURE tcolumns.swap_columns(i1,i2:INTEGER);
VAR p:POINTER;
BEGIN
  swap_integer(co_hash.hash^[co^[i1]^.cha],
               co_hash.hash^[co^[i2]^.cha]);
  p:=co^[i1]; co^[i1]:=co^[i2]; co^[i2]:=p;
END;
{---------------------------------------------------------------------------}
CONSTRUCTOR tladder.init(number:LONGINT);
BEGIN
  coben:=number; GETMEM(cm,SIZEOF(waag)*LONGINT(coben));
END;
{---------------------------------------------------------------------------}
DESTRUCTOR tladder.done;
BEGIN
  FREEMEM(cm,SIZEOF(waag)*coben); cm:=NIL; coben:=0;
END;
{---------------------------------------------------------------------------}
PROCEDURE tladder.longer(number:LONGINT);
VAR m1:tladder;
BEGIN
  m1.init(coben+number);
  MOVE(cm^,m1.cm^,SIZEOF(waag)*coben);
  { FOR i:=1 TO anzahl-1 DO m1^[i]:=m^[i]; }
  done; cm:=m1.cm; coben:=m1.coben;
END;
{---------------------------------------------------------------------------}
CONSTRUCTOR tetha.init(n:INTEGER);
BEGIN
  netha:=0; maxetha:=n; nelemen:=0;
  GETMEM(etha,LONGINT(maxetha)*SIZEOF(tet));
END;
{---------------------------------------------------------------------------}
DESTRUCTOR tetha.done;
BEGIN
  clear_etha(0,nelemen); FREEMEM(etha,LONGINT(maxetha)*SIZEOF(tet)); maxetha:=0; etha:=NIL;
END;
{---------------------------------------------------------------------------}
CONSTRUCTOR tet.init(n:INTEGER);
BEGIN
  init(n);
END;
{---------------------------------------------------------------------------}
DESTRUCTOR tet.done;
BEGIN
  done;
END;
{---------------------------------------------------------------------------}
PROCEDURE tet.clear_etha(n:INTEGER; VAR nelemen:LONGINT);
VAR i:INTEGER;
BEGIN
  FOR i:=netha DOWNTO n+1 DO
  BEGIN
    DEC(nelemen,etha^[i].coben);
    etha^[i].done; DEC(netha);
  END;
END;
{---------------------------------------------------------------------------}
CONSTRUCTOR tcolumn.init(name_:STRING_type; kind:SHORTINT);
BEGIN
  tladder.init(inkrem);
  IF kind=0 THEN lo_bound:=-up_bound_lmt
  ELSE           lo_bound:=0;
  dj:=0; up_bound:=up_bound_lmt; cost:=0; float:=0; 
  int_value:=0; canzahl:=0; spa_:=name_; on_upper:=-1; art:=kind;
  allowed:=TRUE; inttype:=0; p_plus:=0; p_minus:=0;
  IF (kind<>0) AND (kind<>5) THEN row_lmax:=maxi(row_lmax,LENGTH(name_));
  col_lmax:=maxi(col_lmax,1+LENGTH(name_)); {cnum:=nvar;}
END;
{---------------------------------------------------------------------------}
DESTRUCTOR tcolumn.done;
BEGIN
  tladder.done;
END;
{---------------------------------------------------------------------------}
CONSTRUCTOR tint_rec.init;
BEGIN
  integer_found:=FALSE; upper_limit:=1e30; lower_limit:=-1e30;
  tiefe:=0; obenstack:=0; weight:=0.001; tbound.init;
END;
{---------------------------------------------------------------------------}
DESTRUCTOR tint_rec.done;
BEGIN
  tbound.done;
END;
{---------------------------------------------------------------------------}
PROCEDURE tfeld.clear;
BEGIN
  FILLCHAR(feld_pointer^,LONGINT(n)*SIZEOF(DOUBLE),0);
END;
{---------------------------------------------------------------------------}
CONSTRUCTOR tfeld.init;
BEGIN
  GETMEM(feld_pointer,LONGINT(n)*SIZEOF(DOUBLE)); clear(n);
END;
{---------------------------------------------------------------------------}
CONSTRUCTOR trow.init(c:CHAR; s_:STRING; h:INTEGER);
BEGIN
  CASE c OF
    'N': gleich:= 2;
    'L': gleich:=-1;
    'E': gleich:= 0;
    'G': gleich:= 1;
  END;
  row_:=s_; rhas:=h; {rnum:=nrows;}
  ranzahl :=0; rm :=NIL; roben :=0; roben_alt:=inkrem;
  ranzahl1:=0; rm1:=NIL; roben1_alt:=1;
  { 1 extra space for EPS-Perturbation of RHS }
  reanzahl:=0; rem:=NIL; reoben:=0;
END;
{---------------------------------------------------------------------------}
DESTRUCTOR trow.done;
BEGIN
  IF rm<>NIL THEN
  BEGIN
    FREEMEM(rm,LONGINT(roben)*SIZEOF(zwaag)); rm:=NIL; ranzahl:=0; roben:=0;
  END;
  IF rm1<>NIL THEN
  BEGIN
    FREEMEM(rm1,LONGINT(roben1_alt)*SIZEOF(POINTER)); rm1:=NIL; ranzahl1:=0;
  END;
  IF rem<>NIL THEN
  BEGIN
    FREEMEM(rem,LONGINT(reoben)*SIZEOF(POINTER)); rem:=NIL; reanzahl:=0;
  END;
END;
{---------------------------------------------------------------------------}
PROCEDURE thash.clearhash;
BEGIN
  FILLCHAR(hash^,LONGINT(hash_alloc)*SIZEOF(INTEGER),0);
END;
{---------------------------------------------------------------------------}
CONSTRUCTOR thash.init(alloc:INTEGER);
BEGIN
  hash_alloc:=alloc;
  GETMEM(hash,LONGINT(hash_alloc)*SIZEOF(INTEGER));
  clearhash;
END;
{---------------------------------------------------------------------------}
DESTRUCTOR thash.done;
BEGIN
  FREEMEM(hash,LONGINT(hash_alloc)*SIZEOF(INTEGER)); hash_alloc:=0; hash:=NIL;
END;
{---------------------------------------------------------------------------}
FUNCTION thash.gethash(VAR s_:STRIN):LONGINT;
VAR i:INTEGER;
    h1:LONGINT;
BEGIN
  {$IFOPT R+} {$DEFINE mit} {$ENDIf}
  {$R-}
  h1:=0;
  {
  FOR i:=1 TO LENGTH(s_) DO
  BEGIN
    IF ODD(i) THEN h1:=h1+LONGINT(ORD(s_[i])) SHL 4
    ELSE           h1:=h1+LONGINT(ORD(s_[i])) SHL (i+2)+1;
  END;
  }

  FOR i:=1 TO LENGTH(s_) DO h1:=h1+LONGINT(ORD(s_[i])- 48)*(hash_mult[i] SHL i);

  i:=h1 MOD hash_alloc;
  IF i<0 THEN i:=i+ hash_alloc;
  gethash:=i;
  {$IFDEF mit} {$R+} {$ENDIF}
  {$UNDEF mit}
END;
{---------------------------------------------------------------------------}
CONSTRUCTOR tcolumns.init;
BEGIN
  col_alloc:=20; GETMEM(co,LONGINT((col_alloc+2))*SIZEOF(ptcolumn));
  co_hash.init(col_alloc*3);
END;
{---------------------------------------------------------------------------}
DESTRUCTOR tcolumns.done;
VAR i:INTEGER;
BEGIN
  FOR i:=nvar DOWNTO -1 DO eliminate_column(i);
  FREEMEM(co,LONGINT((col_alloc+2))*SIZEOF(ptcolumn)); co:=NIL; co_hash.done;
END;
{---------------------------------------------------------------------------}
CONSTRUCTOR trows.init;
BEGIN
  row_alloc:=20; GETMEM(ro,LONGINT(row_alloc)*SIZEOF(ptrow));
  nrows:=0; ro_hash.init(row_alloc*3);
END;
{---------------------------------------------------------------------------}
DESTRUCTOR trows.done;
VAR i:INTEGER;
BEGIN
  FOR i:=1 TO nrows DO
  BEGIN
    DISPOSE(ro^[i]); ro^[i]:=nil;
  END;
  FREEMEM(ro,LONGINT(row_alloc)*SIZEOF(ptrow)); row_alloc:=0; ro:=NIL; ro_hash.done;
END;
{---------------------------------------------------------------------------}
PROCEDURE tcolumns.eliminate_column(i:INTEGER);
BEGIN
  swap_columns(i,nvar); co_hash.hash^[co^[nvar]^.cha]:=0; co^[nvar]^.done;
  DISPOSE(co^[nvar]); co^[nvar]:=NIL; DEC(nvar);
END;
{---------------------------------------------------------------------------}
PROCEDURE tcolumns.put_col_hash;
VAR i,h:INTEGER;
LABEL 1;
BEGIN
  co_hash.clearhash;
  WITH co_hash DO FOR i:=-1 TO nvar DO WITH co^[i]^ DO
  BEGIN
    h:=gethash(spa_);
    REPEAT
      IF hash^[h]=0 THEN
      BEGIN
        hash^[h]:=i; cha:=h; GOTO 1;
      END;
      INC(h);
      IF h>=hash_alloc THEN h:=0;
    UNTIL FALSE;
    1:
  END;
END;
{---------------------------------------------------------------------------}
PROCEDURE tcolumns.re_alloc_columns;
VAR ch:phash_feld;
    coo:tpcolumn_array;
    col_alloc_new,hash_alloc_new:LONGINT;
BEGIN
  col_alloc_new:=mini(col_alloc*2,maxcolumn);
  GETMEM(coo,   LONGINT((2+col_alloc_new))*SIZEOF(ptcolumn));
  MOVE(co^,coo^,LONGINT((2+col_alloc    ))*SIZEOF(ptcolumn));
  FREEMEM(co,   LONGINT((2+col_alloc    ))*SIZEOF(ptcolumn));
  co:=coo; col_alloc:=col_alloc_new;
  WITH co_hash DO
  BEGIN
    hash_alloc_new:=mini(col_alloc_new*3,2*maxcolumn);
    GETMEM(ch,     LONGINT((hash_alloc_new))*SIZEOF(INTEGER));
    MOVE(hash^,ch^,LONGINT( hash_alloc     )*SIZEOF(INTEGER));
    FREEMEM(hash  ,LONGINT( hash_alloc     )*SIZEOF(INTEGER));
    hash:=ch; hash_alloc:=hash_alloc_new;
  END;
  put_col_hash;
END;
{---------------------------------------------------------------------------}
FUNCTION tcolumns.search_column(s_:STRIN; kind:SHORTINT):INTEGER;
VAR i:INTEGER;
    h:INTEGER;
LABEL 1;
BEGIN
  WITH co_hash DO
  BEGIN
    1:
    h:=gethash(s_);
    REPEAT
      IF hash^[h]=0 THEN { not defined until now }
      BEGIN
        IF kind=-3 THEN
        BEGIN
          search_column:=0; EXIT;
        END;
        INC(nvar);
        IF nvar>maxcolumn THEN
        BEGIN
          my_message('FATAL ERROR'#10#13'MAXcolumn TOO SMALL'); HALT;
        END;
        IF nvar>col_alloc THEN
        BEGIN
          DEC(nvar); re_alloc_columns; GOTO 1;
        END;
        NEW(co^[nvar]); co^[nvar]^.init(s_,kind); search_column:=nvar;
        hash^[h]:=nvar; co^[nvar]^.cha:=h; EXIT;
      END
      ELSE
      IF co^[hash^[h]]^.spa_=s_ THEN
      BEGIN
        search_column:=hash^[h]; EXIT;
      END;
      INC(h);
      IF h>=hash_alloc THEN h:=0;
    UNTIL FALSE;
  END;
END;
{---------------------------------------------------------------------------}
FUNCTION trows.search_row(s_:STRIN):INTEGER;
VAR h:INTEGER;
BEGIN
  WITH ro_hash DO
  BEGIN
    h:=gethash(s_);
    REPEAT
      IF hash^[h]=0 THEN
      BEGIN
        search_row:=0; EXIT;
      END
      ELSE IF ro^[hash^[h]]^.row_=s_ THEN
      BEGIN
        search_row:=hash^[h]; EXIT;
      END;
      INC(h);
      IF h>=hash_alloc THEN h:=0;
    UNTIL FALSE
  END;
  search_row:=0;
END;
{---------------------------------------------------------------------------}
FUNCTION tcolumns.get_optimal_value(col_:STRIN):DOUBLE;
BEGIN
  get_optimal_value:=co^[search_column(col_,0)]^.float;
END;
{---------------------------------------------------------------------------}
FUNCTION tcolumns.get_optimal_dj(col_:STRIN):DOUBLE;
BEGIN
  get_optimal_dj:=co^[search_column(col_,0)]^.dj;
END;
{---------------------------------------------------------------------------}
FUNCTION tcolumns.get_optimal_int_value(col_:STRIN):SINGLE;
BEGIN
  get_optimal_int_value:=co^[search_column(col_,0)]^.int_value;
END;
{---------------------------------------------------------------------------}
FUNCTION tcolumns.get_optimal_int_dj(col_:STRIN):SINGLE;
BEGIN
  get_optimal_int_dj:=co^[search_column(col_,0)]^.int_dj;
END;
{---------------------------------------------------------------------------}
FUNCTION tcolumns.get_optimal_row_value(col_:STRIN):DOUBLE;
BEGIN
  get_optimal_row_value:=co^[search_column(col_,0)]^.float;
END;
{---------------------------------------------------------------------------}
FUNCTION tcolumns.get_optimal_row_dj(col_:STRIN):DOUBLE;
BEGIN
  get_optimal_row_dj:=co^[search_column(col_,0)]^.dj;
END;
{---------------------------------------------------------------------------}
FUNCTION tcolumns.get_optimal_row_int_value(col_:STRIN):SINGLE;
BEGIN
  get_optimal_row_int_value:=co^[search_column(col_,0)]^.int_value;
END;
{---------------------------------------------------------------------------}
FUNCTION tcolumns.get_optimal_row_int_dj(col_:STRIN):SINGLE;
BEGIN
  get_optimal_row_int_dj:=co^[search_column(col_,0)]^.int_dj;
END;
{---------------------------------------------------------------------------}
FUNCTION tcolumns.get_entry(row,column:INTEGER):DOUBLE;
VAR i:INTEGER;
BEGIN
  WITH co^[column]^ DO FOR i:=1 TO canzahl DO WITH cm^[i] DO IF z=row THEN
  BEGIN
    get_entry:=wert; EXIT;
  END;
  get_entry:=0;
END;
{---------------------------------------------------------------------------}
FUNCTION tcolumns.get_range(row:INTEGER):DOUBLE;
VAR i:INTEGER;
BEGIN
  WITH co^[-1]^ DO FOR i:=1 TO canzahl DO WITH cm^[i] DO IF z=row THEN
  BEGIN
    get_range:=wert; EXIT;
  END;
  get_range:=0;
END;
{---------------------------------------------------------------------------}
PROCEDURE tcolumns.qsort_dj(li,re:INTEGER);
VAR i,j:INTEGER;
    d:DOUBLE;
BEGIN
  i:=li; j:=re; d:=co^[(li+re) DIV 2]^.dj;
  REPEAT
    WHILE (i<=re) AND (d>co^[i]^.dj) DO INC(i);
    WHILE (j>=li) AND (d<co^[j]^.dj) DO DEC(j);
    IF i<=j THEN
    BEGIN
      swap_columns(i,j); INC(i); DEC(j);
    END;
  UNTIL i>j;
  IF li<j THEN qsort_dj(li,j);
  IF i<re THEN qsort_dj(i,re);
END;
{----------------------------------------------------------------------------}
FUNCTION tbound.add(VAR sr:stack_row):INTEGER;
VAR hilf_:STRIN;
BEGIN
  INC(nbounds); STR(nbounds:5,hilf_);
  scr.win_out(koonbounds,hilf_);
  IF nbounds>=maxbound*(nboundfeld+1) THEN
  BEGIN
    INC(nboundfeld); NEW(bounds[nboundfeld]);
  END;
  bounds[nbounds DIV maxbound]^[nbounds MOD maxbound]:=sr;
  add:=nbounds;
END;
{----------------------------------------------------------------------------}
FUNCTION tbound.search_bound(VAR sr:stack_row):INTEGER;
VAR i:INTEGER;
BEGIN
  FOR i:=1 TO nbounds DO WITH bounds[i DIV maxbound]^[i MOD maxbound] DO
  IF (ch=sr.ch) AND (neu=sr.neu) AND (bo=sr.bo) AND (old=sr.old) AND (ch=sr.ch) THEN
  BEGIN
    search_bound:=i; EXIT;
  END;
  search_bound:=add(sr); ;
END;
{----------------------------------------------------------------------------}
FUNCTION tbound.save_bounds(fname_:STRIN):INTEGER;
VAR bound_file:FILE OF stack_row;
    i:INTEGER;
BEGIN
  {$IFDEF win32}
  SYSTEM.ASSIGNFILE(bound_file,COPY(fname_,1,POS('.',fname_))+'BOU');
  {$ELSE}
  SYSTEM.ASSIGN(bound_file,COPY(fname_,1,POS('.',fname_))+'BOU');
  {$ENDIF}
  REWRITE(bound_file);
  {$IFDEF win32}
    LpForm.addmemo('SAVE TREE');
  {$ELSE}
    WRITELN('SAVE TREE');
  {$ENDIF}
  save_bounds:=nbounds;
  FOR i:=1 TO nbounds DO WRITE(bound_file,bounds[i DIV maxbound]^[i MOD maxbound]);
  done;
  {$IFDEF win32}
  SYSTEM.CLOSEFILE(bound_file);
  {$ELSE}
  SYSTEM.CLOSE(bound_file);
  {$ENDIF}
END;
{----------------------------------------------------------------------------}
DESTRUCTOR tbound.done;
VAR i:INTEGER;
BEGIN
  FOR i:=0 TO nboundfeld DO
  BEGIN
    DISPOSE(bounds[i]); bounds[i]:=NIL;
  END;
  nboundfeld:=-1; nbounds:=0;
END;
{----------------------------------------------------------------------------}
CONSTRUCTOR tbound.init;
BEGIN
  nbounds:=0; nboundfeld:=-1;
END;
{----------------------------------------------------------------------------}
PROCEDURE tbound.read_bounds(nbo:INTEGER; fname_:STRIN);
VAR bound_file:FILE OF stack_row;
    i:INTEGER;
BEGIN
  {$IFDEF win32}
  ASSIGNFILE(bound_file,COPY(fname_,1,POS('.',fname_))+'BOU');
  {$ELSE}
  ASSIGN(bound_file,COPY(fname_,1,POS('.',fname_))+'BOU');
  {$ENDIF}
  RESET(bound_file);
  nbounds:=nbo;
  nboundfeld:=nbounds DIV maxbound;
  FOR i:=0 TO nboundfeld DO NEW(bounds[i]);
  FOR i:=1 TO nbounds DO READ(bound_file,bounds[i DIV maxbound]^[i MOD maxbound]);
  {$IFDEF win32}
  CLOSEFILE(bound_file);
  {$ELSE}
  CLOSE(bound_file);
  {$ENDIF}
END;
{----------------------------------------------------------------------------}
PROCEDURE tbound.get_bound(i:INTEGER; VAR sr:stack_row);
BEGIN
  IF i>nbounds THEN
  BEGIN
    WRITELN('I > nbounds ',i,' ',nbounds); HALT;
  END;
  sr:=bounds[i DIV maxbound]^[i MOD maxbound];
END;
{----------------------------------------------------------------------------}
PROCEDURE sc.textcolor(c:INTEGER);
BEGIN
  IF NOT with_output THEN EXIT;
  {$IFDEF win32}
  LpForm.memo1.font.color:=C;
  {$ELSE}
  CRT.TEXTCOLOR(c);
  {$ENDIF}
END;
{----------------------------------------------------------------------------}
PROCEDURE sc.textbackground(c:INTEGER);
BEGIN
  IF NOT with_output THEN EXIT;
  {$IFDEF win32}
  LpForm.memo1.color:=C;
  {$ELSE}
  CRT.textbackground(c);
  {$ENDIF}
END;
{----------------------------------------------------------------------------}
CONSTRUCTOR sc.init;
BEGIN
  with_output:=TRUE;
  {$IFNDEF win32} NOSOUND; CHECKBREAK:=FALSE; {$ENDIF}
END;
{----------------------------------------------------------------------------}
PROCEDURE sc.set_output(s:BOOLEAN);
BEGIN
  with_output:=s;
END;
{----------------------------------------------------------------------------}
DESTRUCTOR sc.done;
BEGIN
END;
{----------------------------------------------------------------------------}
PROCEDURE sc.clrscr;
BEGIN
  IF NOT with_output THEN EXIT;
  {$IFDEF win32}
  LpForm.memo1.clear;
  {$ELSE}
  CRT.CLRSCR;
  {$ENDIF}
END;
{----------------------------------------------------------------------------}
PROCEDURE sc.window(x1,x2,x3,x4:INTEGER);
BEGIN
  IF NOT with_output THEN EXIT;
  {$IFNDEF win32}
  CRT.WINDOW(x1,x2,x3,x4);
  {$ENDIF}
END;
{----------------------------------------------------------------------------}
PROCEDURE sc.GOTOXY(x,y:INTEGER);
BEGIN
  IF NOT with_output THEN EXIT;
  {$IFNDEF win32}
  CRT.GOTOXY(x,y);
  {$ENDIF}
END;
{----------------------------------------------------------------------------}
FUNCTION sc.wherex:INTEGER;
BEGIN
  IF NOT with_output THEN EXIT;
  {$IFNDEF win32}
  wherex:=CRT.wherex;
  {$ENDIF}
END;
{----------------------------------------------------------------------------}
FUNCTION sc.wherey:INTEGER;
BEGIN
  IF NOT with_output THEN EXIT;
  {$IFNDEF win32}
  wherey:=CRT.wherey;
  {$ENDIF}
END;
{----------------------------------------------------------------------------}
PROCEDURE sc.WRITE(s_:STRIN);
BEGIN
  IF NOT with_output THEN EXIT;
  {$IFDEF win32}
  LpForm.addmemo(s_);
  {$ELSE}
  SYSTEM.WRITE(s_);
  {$ENDIF}
END;
{----------------------------------------------------------------------------}
PROCEDURE sc.WRITELN(s_:STRIN);
BEGIN
  IF NOT with_output THEN EXIT;
  {$IFDEF win32}
  LpForm.addmemo(s_);
  {$ELSE}
  SYSTEM.WRITELN(s_);
  {$ENDIF}
END;
{----------------------------------------------------------------------------}
PROCEDURE sc.inversion(s_:STRIN);
BEGIN
  IF NOT with_output THEN EXIT;
  {$IFDEF win32}
  LpForm.label8.caption:=s_; application.processmessages;
  {$ENDIF}
END;
{----------------------------------------------------------------------------}
PROCEDURE sc.inf_2;
BEGIN
  IF NOT with_output THEN EXIT;
  {$IFDEF win32}
    LpForm.label8.caption:=''; application.processmessages;
  {$ELSE}
    GOTOXY(1,WHEREY); CLREOL;
  {$ENDIF}
END;
{----------------------------------------------------------------------------}
PROCEDURE sc.remove_eps;
VAR wx:WORD;
BEGIN
  IF NOT with_output THEN EXIT;
  {$IFDEF win32}
  LpForm.appendmemo(' REMOVE EPS ');
  {$ELSE}
  wx:=WHEREX; WRITE(' REMOVE EPS '); CLREOL; GOTOXY(wx,WHEREY);
  {$ENDIF}
END;
{----------------------------------------------------------------------------}
PROCEDURE sc.add_eps(n:INTEGER);
VAR wx:WORD;
BEGIN
  IF NOT with_output THEN EXIT;
  {$IFDEF win32}
  LpForm.appendmemo(' EPS '+ltoa(n));
  {$ELSE}
  wx:=WHEREX; WRITE(' EPS '+ltoa(n)); CLREOL; GOTOXY(wx,WHEREY);
  {$ENDIF}
END;
{----------------------------------------------------------------------------}
PROCEDURE sc.noise;
BEGIN
  IF NOT with_output THEN EXIT;
  {$IFDEF win32}
    BEEP; BEEP; BEEP;
  {$ELSE}
    SOUND(1000); DELAY(10); NOSOUND;
  {$ENDIF}
END;
{----------------------------------------------------------------------------}
PROCEDURE sc.int_start;
VAR ii:INTEGER;
BEGIN
  IF NOT with_output THEN EXIT;
  {$IFDEF win32}
    LpForm.label6.caption:='NONINT  VECTOR      NEW     OLD       PSEUDO            OBJF';
  {$ELSE}
    scr.win_out(koointstatus,laenge(' ',79,' '));
    ii:=maxi(6,WHEREY); WINDOW(1,1,80,25); GOTOXY(1,5);
    WRITE('NONINT  VECTOR      NEW     OLD       PSEUDO         OBJF');
    CLREOL; WINDOW(1,6,80,25); GOTOXY(1,ii);
    win_out(koonodes,'NODES OPEN         HIT         TOT');
    win_out(koobounds,'                          BOUNDS');
  {$ENDIF}
END;
{----------------------------------------------------------------------------}
PROCEDURE sc.delay(ms:LONGINT);
BEGIN
  {$IFNDEF win32}
  CRT.DELAY(ms);
  {$ENDIF}
END;
{----------------------------------------------------------------------------}
FUNCTION sc.readkey:CHAR;
BEGIN
  {$IFNDEF win32}
  readkey:=CRT.READKEY;
  {$ENDIF}
END;
{----------------------------------------------------------------------------}
FUNCTION sc.keypressed:BOOLEAN;
BEGIN
  {$IFNDEF win32}
  keypressed:=CRT.KEYPRESSED;
  {$ENDIF}
END;
{----------------------------------------------------------------------------}
PROCEDURE sc.win_out(k:koo; s_:STRIN);
VAR wx,wy:INTEGER;
BEGIN
  IF NOT with_output THEN EXIT;
  {$IFDEF win32}
  CASE k.y OF
    0: CASE k.x OF
         0: LpForm.label5.caption :=s_;
       END;
    1: CASE k.x OF
         0:  LpForm.label6.caption :=s_;
         63: LpForm.label2.caption :=s_;
       END;
    2: CASE k.x OF
         63: LpForm.label3.caption :=s_;
         75: LpForm.label9.caption :=s_;
       END;
    3: CASE k.x OF
         1:  LpForm.label4.caption :=s_;
         17: LpForm.label7.caption :=s_;
         49: LpForm.label13.caption:=s_;
         60: LpForm.label21.caption:=s_;
         72: LpForm.label16.caption:=s_;
       END;
    4: CASE k.x OF
          1: LpForm.label15.caption:=s_;
         40: LpForm.label18.caption:=s_;
         50: LpForm.label23.caption:=s_;
         59: LpForm.label10.caption:=s_;
         75: LpForm.label11.caption:=s_;
       END;
    5: LpForm.label19.caption:=s_;
    7: LpForm.label7.caption :=s_;
  END;
  {$ELSE}
  wx:=WHEREX; wy:=WHEREY; WINDOW(1,1,80,25);
  GOTOXY(k.x,k.y); WRITE(s_);
  WINDOW(1,6,80,25); GOTOXY(wx,wy);
  {$ENDIF}
END;
{----------------------------------------------------------------------------}
CONSTRUCTOR tsos2_obj.init;
VAR i,j:INTEGER;
BEGIN
  nsos2:=0;
  FOR i:=1 TO max_sos2 DO sos2[i]:=NIL;
END;
{----------------------------------------------------------------------------}
DESTRUCTOR tsos2_obj.done;
VAR i,j:INTEGER;
BEGIN
  FOR i:=1 TO nsos2 DO
  BEGIN
    sos2[i]^.done; DISPOSE(sos2[i]);
  END;
  nsos2:=0;
END;
{----------------------------------------------------------------------------}
PROCEDURE tsos2_obj.define_sos2(so_,col_:STRING);
VAR i,j:INTEGER;
    xxx:pstring_type_feld;
BEGIN
  FOR i:=1 TO nsos2 DO WITH sos2[i]^ DO IF sos2_name_=so_ THEN
  BEGIN
    add(col_); EXIT;
  END;
  IF nsos2=max_sos2 THEN
  BEGIN
    my_message('Too many SOS2 defined '+so_); HALT;
  END;
  INC(nsos2);
  NEW(sos2[nsos2]);
  WITH sos2[nsos2]^ DO
  BEGIN
    init(so_);
    define_sos2(so_,col_);
  END;
END;
{----------------------------------------------------------------------------}
CONSTRUCTOR tsos2_row.init(so_:STRING);
BEGIN
  nsos2_elements_max:=0; nsos2_elements:=0;
  sos2_:=NIL;
  sos2_name_:=so_;
END;
{----------------------------------------------------------------------------}
DESTRUCTOR tsos2_row.done;
BEGIN
  FREEMEM(sos2_,nsos2_elements_max*SIZEOF(string_type)); sos2_:=NIL;
  nsos2_elements_max:=0; nsos2_elements:=0;
  sos2_name_:=''
END;
{----------------------------------------------------------------------------}
PROCEDURE tsos2_row.add(s_:STRING);
VAR xxx:pstring_type_feld;
BEGIN
  IF nsos2_elements_max=nsos2_elements THEN
  BEGIN
    GETMEM(xxx,      (nsos2_elements_max+5)*SIZEOF(string_type));
    MOVE(sos2_^ ,xxx^,nsos2_elements_max   *SIZEOF(string_type));
    FREEMEM(sos2_,    nsos2_elements_max   *SIZEOF(string_type));
    sos2_:=xxx;   INC(nsos2_elements_max,5);
  END;
  INC(nsos2_elements);
  sos2_^[nsos2_elements]:=s_;
END;
END.
