UNIT lp_form;

INTERFACE

USES
  Windows, Messages, SysUtils, Classes, Graphics,Controls, Forms,
  Dialogs,Menus,util,StdCtrls, Grids, ComCtrls, ExtCtrls,go_lp,tty;

TYPE
  TlpForm = CLASS(TForm)
    MainMenu1: TMainMenu;
    mnuOther: TMenuItem;
    mnuInvert: TMenuItem;
    mnuEpsilonClick: TMenuItem;
    Status1: TMenuItem;
    MixColumns1: TMenuItem;
    BasiswithSlacks1: TMenuItem;
    mnuEdit: TMenuItem;
    mnuEDITVector: TMenuItem;
    mnuEDITParameter: TMenuItem;
    mnuEDITInfeasible: TMenuItem;
    mnuEDITDemystified: TMenuItem;
    mnuHelp: TMenuItem;
    mnuHelpAbout: TMenuItem;
    mnuFile: TMenuItem;
    mnuLoad: TMenuItem;
    mnuSave: TMenuItem;
    mnuEXIT: TMenuItem;
    mnuNew: TMenuItem;
    mnuOptimize: TMenuItem;
    mnuOPTIMIZEMaximize: TMenuItem;
    mnuOptimizeMinimize: TMenuItem;
    mnuOptimizeSolve_MIP: TMenuItem;
    mnuOPTIMIZECancel: TMenuItem;
    mnuCommand_File: TMenuItem;
    mnuCrashBasis: TMenuItem;
    mnuOptimizeSolve_LP: TMenuItem;
    mnuSelectObjective: TMenuItem;
    mnuMPSX_l: TMenuItem;
    mnuMPSXFormatted: TMenuItem;
    mnuLP_l: TMenuItem;
    mnuBasis_l: TMenuItem;
    mnuTree_l: TMenuItem;
    mnuCRLF: TMenuItem;
    mnuMPSX_s: TMenuItem;
    mnuMPSXWithoutSpaces: TMenuItem;
    mnuLP_s: TMenuItem;
    mnuBasis_s: TMenuItem;
    mnuSolution: TMenuItem;
    mnuSolutionCSV: TMenuItem;
    mnuIntegerSolution: TMenuItem;
    mnuIntegerSolutionCSV: TMenuItem;
    mnuHelpMain: TMenuItem;
    StringGrid1: TStringGrid;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    ProgressBar1: TProgressBar;
    Edit2: TEdit;
    Timer1: TTimer;
    Timer2: TTimer;
    Memo1: TMemo;
    PROCEDURE keyevent(SENDer: TObject; var Key: Word; Shift: TShiftState);
    PROCEDURE mnuEpsilonClickClick(SENDer: TObject);
    PROCEDURE mnuInvertClick(SENDer: TObject);
    PROCEDURE mnuEDITDemystifiedClick(SENDer: TObject);
    PROCEDURE mnuEDITInfeasibleClick(SENDer: TObject);
    PROCEDURE BasiswithSlacks1Click(SENDer: TObject);
    PROCEDURE mnuLoadLPClick(SENDer: TObject);
    PROCEDURE Status1Click(SENDer: TObject);
    PROCEDURE MixColumns1Click(SENDer: TObject);
    PROCEDURE mnuEDITParameterClick(SENDer: TObject);
    PROCEDURE StringGrid1KeyUp(SENDer: TObject; var Key: Word; Shift: TShiftState);
    PROCEDURE tlpformshow(SENDer: TObject);
    PROCEDURE edit2_key(SENDer: TObject; var Key: Word;
       Shift: TShiftState);
    PROCEDURE prog_quit(SENDer: TObject; var Action: TCloseAction);
    PROCEDURE Timer1Timer(SENDer: TObject);
    PROCEDURE LP_create(SENDer: TObject);
    PROCEDURE mnuHelpClick(SENDer: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure eXit1Click(Sender: TObject);
    procedure Cancel1Click(Sender: TObject);
    procedure mnuCrashBasisClick(Sender: TObject);
    procedure mnuNewClick(Sender: TObject);
    procedure mnuOPTIMIZEMaximizeClick(Sender: TObject);
    procedure mnuOptimizeMinimizeClick(Sender: TObject);
    procedure mnuOptimizeSolve_LPClick(Sender: TObject);
    procedure mnuOptimizeSolve_MIPClick(Sender: TObject);
    procedure mnuCommand(Sender: TObject);
    procedure mnuMPSX_lClick(Sender: TObject);
    procedure mnuMPSXFormattedClick(Sender: TObject);
    procedure mnuLP_lClick(Sender: TObject);
    procedure mnuBasis_lClick(Sender: TObject);
    procedure mnuTree_lClick(Sender: TObject);
    procedure mnuCRLFClick(Sender: TObject);
    procedure mnuSolutionClick(Sender: TObject);
    procedure mnuSolutionCSVClick(Sender: TObject);
    procedure mnuIntegerSolutionClick(Sender: TObject);
    procedure mnuIntegerSolutionCSVClick(Sender: TObject);
    procedure mnuLP_sClick(Sender: TObject);
    procedure mnuMPSX_sClick(Sender: TObject);
    procedure mnuMPSXWithoutSpacesClick(Sender: TObject);
    procedure mnuBasis_sClick(Sender: TObject);
    procedure mnuHelpAboutClick(Sender: TObject);
    procedure on_close_query(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
    PROCEDURE addmemo(s_:STRIN);
    PROCEDURE appendmemo(s_:STRIN);
    PROCEDURE replace(s_:STRIN);
    PROCEDURE clear_label;
  END;

var lpForm: TlpForm;
    memomaxlines:WORD;
    edit_ready,edit_valid:BOOLEAN;
    lp_solver:tlp6;
    implementation

uses lo1;
{$R *.DFM}

PROCEDURE tlpForm.addmemo(s_:STRIN);
BEGIN
  WITH LpForm.memo1 DO
  BEGIN
    IF lines.count>memomaxlines THEN clear;
    IF lines.add(s_)<10000 THEN;
  END;
END;
{-----------------------------------------------------------}
PROCEDURE tlpForm.appendmemo(s_:STRIN);
VAR s2_:STRIN;
BEGIN
  WITH LpForm.memo1 DO
  BEGIN
    {lines[lines.count-1]:=lines[lines.count-1]+s_;}
    s2_:=lines[lines.count-1]+s_;
    lines.delete(lines.count-1);
    LpForm.addmemo(s2_);
  END;
END;
{-----------------------------------------------------------}
PROCEDURE tlpForm.replace(s_:STRIN);
BEGIN
  WITH LpForm.memo1 DO
  BEGIN
    {lines[lines.count-1]:=lines[lines.count-1]+s_;}
    lines.delete(lines.count-1);
    LpForm.addmemo(s_);
  END;
END;
{-----------------------------------------------------------}
PROCEDURE TlpForm.keyevent(SENDer:TObject; var Key:Word; Shift:TShiftState);
BEGIN
  WITH lp_Solver DO
  BEGIN
    stat_pressed:=TRUE;
    CASE key OF
      187: { + }
      BEGIN
        npricing:=longint(npricing)*2; nne:=0;
      END;
      189: { - } npricing:=maxi(1,npricing div 2);
      65,97: { a,A }
      IF stat_integer_mode THEN WITH int_rec DO max_memory:=100000;
      68,100: { D, d }
      IF      iterlog=0   THEN iterlog:=100
      ELSE IF iterlog=100 THEN iterlog:=-10
      ELSE                     iterlog:=  0;
      77,109: { m, M } IF stat_integer_mode THEN stat_grafikm:=TRUE;
      78,110: { n, N } IF stat_integer_mode THEN stat_grafikn:=TRUE;
      79,111: { o, O } IF stat_integer_mode THEN stat_grafiko:=TRUE;
      83,115: { s,S  } stat_save:=TRUE;
      84,116: { T, t } stat_togg:=TRUE;
      87,119: { w,W }
      IF stat_integer_mode THEN
      WITH int_rec DO max_memory:=maxi(mini(max_memory,wtiefe)-100,10);
      88,120: { x,X }
      IF stat_integer_mode THEN WITH int_rec DO
      max_memory:=2*wtiefe+100;
      112: IF application.helpjump('iteration') THEN;
    END;
  END;
END;
{-----------------------------------------------------------}
PROCEDURE TlpForm.clear_label;
BEGIN
  WITH LpForm DO
  BEGIN
    caption:='LP-SOLVER '+lp_solver.fname_;  { File }
    label2.caption:='';  { Memavail }
    label3.caption:='';  { minpiv }
    label4.caption:='';  { ninf, netha, nelemen }
    {label5.caption:=''};  { Matrix Dimension }
    {label6.caption:=''};  { Titel of Memo }
    label7.caption:='';  { read save nodes }
    label8.caption:='';  { Inversion }
    label9.caption:='';  { non negative dj NNE }
    label10.caption:='';  { new pseudocosts neeu }
    label11.caption:='';
    label13.caption:='';
    label15.caption:='';  { Int Status }
    label16.caption:='';  { total Nodes searched }
    label18.caption:='';  { ngleich }
    label19.caption:='';  { INT SOL FOUND}
    label21.caption:='';  { Hit }
    label22.caption:='nDj';  { maxavail }
    label23.caption:='';  { count minnz }
  END;
END;
{-----------------------------------------------------------}
PROCEDURE TlpForm.mnuEpsilonClickClick(SENDer: TObject);
BEGIN
  WITH lp_solver DO CASE with_eps OF
    0: toggle_epsilon(1);
    1: toggle_epsilon(2);
    2: toggle_epsilon(0);
  END;
END;
{-----------------------------------------------------------}
PROCEDURE TlpForm.mnuInvertClick(SENDer: TObject);
BEGIN
  lp_solver.inversion;
END;
{-----------------------------------------------------------}
PROCEDURE TlpForm.mnuEDITDemystifiedClick(SENDer: TObject);
BEGIN
  lp_solver.demyst; memomaxlines:=24;
END;
{-----------------------------------------------------------}
PROCEDURE TlpForm.mnuEDITInfeasibleClick(SENDer: TObject);
BEGIN
  lp_solver.show_infeasible; memomaxlines:=24;
END;
{-----------------------------------------------------------}
PROCEDURE TlpForm.BasiswithSlacks1Click(SENDer: TObject);
BEGIN
  lp_solver.basis_of_rows;
END;
{-----------------------------------------------------------}
PROCEDURE TlpForm.mnuLoadLPClick(SENDer: TObject);
BEGIN
END;
{-----------------------------------------------------------}
PROCEDURE TlpForm.Status1Click(SENDer: TObject);
BEGIN
  lp_solver.output_status;
END;
{-----------------------------------------------------------}
PROCEDURE tlpform.MixColumns1Click(SENDer: TObject);
BEGIN
  lp_solver.mischen;
END;
{-----------------------------------------------------------}
PROCEDURE TlpForm.mnuEDITParameterClick(SENDer: TObject);
VAR i:INTEGER;
BEGIN
  WITH LpForm.stringgrid1 DO WITH lp_solver DO 
  BEGIN
    defaultrowheight:=15; fixedcols:=1;
    rowcount:=lp_par.npar; enabled:=TRUE; colcount:=2;
    lp_par.fill_edit(3); height:=defaultrowheight*rowcount+defaultrowheight+20;
    WITH lp_par DO FOR i:=1 TO npar DO
    BEGIN
      cells[0,i-1]:=p^[i].grid1_.get;
      cells[1,i-1]:=p^[i].grid2_.get;
    END;
    visible:=TRUE; enabled:=TRUE; setfocus; memo1.hide;
    options:=[gofixedvertline,gofixedhorzline,gohorzline,govertline,
    goalwaysshoweditor,gocolsizing,goediting,gotabs];
  END;
END;
{-----------------------------------------------------------}
PROCEDURE TlpForm.StringGrid1KeyUp(SENDer: TObject; var Key: Word; Shift: TShiftState);
VAR fp:TEXTFILE;
    i:INTEGER;
BEGIN
  { Escape }
  IF key=27 THEN WITH LpForm.stringgrid1 DO WITH lp_Solver DO 
  BEGIN
    visible:=FALSE; enabled:=FALSE; memo1.show;
    lpform.setfocus;
    WITH lp_par DO FOR i:=1 TO npar DO WITH p^[i] DO
    BEGIN
      grid1_.done; grid2_.done;
    END;
  END;
  IF key=13 THEN WITH lp_solver DO WITH lp_par DO
  BEGIN
    memo1.show;
    WITH lp_par DO FOR i:=1 TO npar DO WITH p^[i] DO
    BEGIN
      grid1_.done; grid2_.done;
    END;
    FOR i:=1 TO npar DO p^[i].grid2_.put(LpForm.stringgrid1.cells[1,i-1]);
    IF read_edit THEN
    BEGIN
      LpForm.stringgrid1.visible:=FALSE;
      LpForm.stringgrid1.enabled:=FALSE;
      setfocus;
      lies_aus_parameter;
      ASSIGNFILE(fp,parameter_); {$I-} REWRITE(fp); {$I+}
      IF IORESULT=0 THEN
      BEGIN
        save_parameter(fp); CLOSEFILE(fp);
      END ELSE my_message('CANNOT WRITE '+parameter_);
      setfocus;
      WITH lp_par DO FOR i:=1 TO npar DO WITH p^[i] DO
      BEGIN
        grid1_.done; grid2_.done;
      END;
    END;
  END;
END;
{-----------------------------------------------------------}
PROCEDURE TlpForm.tlpformshow(SENDer: TObject);
BEGIN
  WITH LpForm DO
  BEGIN
    memomaxlines:=24;
    clear_label;
    LpForm.stringgrid1.enabled:=FALSE;
    memo1.clear; memo1.readonly:=TRUE;
    caption:='LP-SOLVER';
    top:=0;
    left:=0;
    WITH stringgrid1 DO
    BEGIN
      enabled:=FALSE; visible:=FALSE; fixedrows:=0; colcount:=2;
      defaultcolwidth:=140; top:=80; left:=10; height:=200;
    END;
  END;
  lp_solver.init;
  chdir(lp_solver.start_path_); application.helpfile:=lp_solver.start_path_+'\LP.HLP';
END;
{-----------------------------------------------------------}
PROCEDURE TlpForm.edit2_key(SENDer: TObject; var Key: Word;
  Shift: TShiftState);
BEGIN
  IF key=13 THEN
  BEGIN
    edit_ready:=TRUE; edit_valid:=TRUE; lpform.setfocus; edit2.hide;
  END
  ELSE IF key=27 THEN
  BEGIN
    edit_ready:=TRUE; lpform.setfocus; edit2.hide;
  END;
END;
{-----------------------------------------------------------}
PROCEDURE TlpForm.prog_quit(SENDer: TObject; var Action: TCloseAction);
BEGIN
  lp_solver.stat_abbruch:=TRUE;
  // lp_solver.quit;
END;
{-----------------------------------------------------------}
PROCEDURE TlpForm.Timer1Timer(SENDer: TObject);
BEGIN
  timer1.enabled:=FALSE;
  IF paramcount>0 THEN
  BEGIN
    setfocus;
    lp_solver.stat_from_command_line:=TRUE;
    lp_solver.execute(ucase(paramstr(1)));
  END;
END;
{-----------------------------------------------------------}
PROCEDURE TlpForm.LP_create(SENDer: TObject);
BEGIN
END;
{-----------------------------------------------------------}
PROCEDURE TlpForm.mnuHelpClick(SENDer: TObject);
BEGIN
  IF application.helpjump('main') THEN;
END;
{-----------------------------------------------------------}
procedure TlpForm.Timer2Timer(Sender: TObject);
begin
  WITH lp_solver DO IF stat_integer_mode THEN WITH int_rec DO
  max_memory:=2*wtiefe+100;
end;
{-----------------------------------------------------------}
procedure TlpForm.eXit1Click(Sender: TObject);
begin
  lp_solver.quit;
  IF application.helpcommand(help_quit,0) THEN;
  application.terminate;
end;
{-----------------------------------------------------------}
procedure TlpForm.Cancel1Click(Sender: TObject);
begin
  IF MessageDlg('Cancel (Y/N) ',mtCustom,mbOkCancel,0)=mrok THEN
  BEGIN
    lp_solver.stat_abbruch:=TRUE; lp_solver.stat_user_abbruch:=TRUE;
  END;
end;
{-----------------------------------------------------------}
procedure TlpForm.mnuCrashBasisClick(Sender: TObject);
begin
  lp_Solver.crash;
end;
{-----------------------------------------------------------}
procedure TlpForm.mnuNewClick(Sender: TObject);
begin
  WITH lp_solver DO
  BEGIN
    new_model;
    {$IFDEF win32}
    LpForm.label2.caption:=laenge(ltoa(getheapstatus.totalallocated DIV 1000),7,' ');
    LpForm.label3.caption:=laenge(ftoa(min_piv),11,' ');
    {$ELSE}
    win_out(koomema,  laenge(ltoa(MEMAVAIL DIV 1000),7,' '));
    win_out(koominpiv,laenge(ftoa(min_piv),11,' '));
    {$ENDIF}
  END;
end;
{-----------------------------------------------------------}
procedure TlpForm.mnuOPTIMIZEMaximizeClick(Sender: TObject);
begin
  lp_solver.set_max;
end;
{-----------------------------------------------------------}
procedure TlpForm.mnuOptimizeMinimizeClick(Sender: TObject);
begin
  lp_solver.set_min;
end;
{-----------------------------------------------------------}
procedure TlpForm.mnuOptimizeSolve_LPClick(Sender: TObject);
begin
  WITH LpForm DO WITH lp_solver DO
  BEGIN
    setfocus; keypreview:=TRUE;
    solve_lp; keypreview:=FALSE;
    IF stat_with_log THEN write_log;
  END;
end;
{-----------------------------------------------------------}
procedure TlpForm.mnuOptimizeSolve_MIPClick(Sender: TObject);
begin
  WITH LpForm DO WITH lp_solver DO
  BEGIN
    label8.caption:='';
    setfocus; keypreview:=TRUE;
    global;
    keypreview:=FALSE;
  END;
end;
{-----------------------------------------------------------}
procedure TlpForm.mnuCommand(Sender: TObject);
begin
  WITH lp_Solver DO
  BEGIN
    stat_user_abbruch:=FALSE; stat_abbruch:=FALSE;
    openDialog1.filename:='*.CMD'; stat_help_index:=36;
    IF opENDialog1.execute THEN
    IF POS('.CMD',ucase(opendialog1.filename))<>0 THEN
    BEGIN
      setfocus; keypreview:=TRUE;
      execute(opENDialog1.filename); keypreview:=FALSE;
    END;
  END;
end;
{-----------------------------------------------------------}
procedure TlpForm.mnuMPSX_lClick(Sender: TObject);
VAR s_:STRIN;
BEGIN
  WITH lp_solver DO
  BEGIN
    Opendialog1.filename:='*.MAT'; stat_help_index:=31;
    IF opendialog1.execute THEN WITH LpForm DO
    BEGIN
      s_:=ucase(opendialog1.filename);
      IF POS('.MAT',s_)<>0 THEN
      BEGIN
        lp_solver.fname_:=s_;
        application.processmessages;
        lies_mpsx; make_rest;
        {$IFNDEF win32} label2.caption:=laenge(ltoa(getheapstatus.totalallocated DIV 1000),7,' ');{$ENDIF}
        lpform.caption:='LP-SOLVER '+fname_+' Direction Maximization';
      END;
    END;
  END;
end;
{-----------------------------------------------------------}
procedure TlpForm.mnuMPSXFormattedClick(Sender: TObject);
begin
  WITH lp_Solver DO
  BEGIN
    opENDialog1.filename:='*.MAT'; stat_help_index:=40;
    IF opENDialog1.execute THEN WITH LpForm DO
    BEGIN
      IF POS('.MAT',ucase(opENDialog1.filename))<>0 THEN
      BEGIN
        fname_:=ucase(opENDialog1.filename);
        lpform.caption:='LP-SOLVER '+fname_+' Direction Maximization';
        application.processmessages;
        lies_mpsx_komplett; make_rest;
        {$IFNDEF win32} label2.caption:=laenge(ltoa(getheapstatus.totalallocated),7,' ');{$ENDIF}
      END;
    END;
  END;
end;
{-----------------------------------------------------------}
procedure TlpForm.mnuLP_lClick(Sender: TObject);
begin
  WITH lp_solver DO
  BEGIN
    opENDialog1.filename:='*.LP'; stat_help_index:=30;
    IF opENDialog1.execute THEN WITH LpForm DO
    BEGIN
      IF POS('.LP',ucase(opENDialog1.filename))<>0 THEN
      BEGIN
        fname_:=ucase(opENDialog1.filename);
        lpform.caption:='LP-SOLVER '+fname_+' Direction Maximization';
        application.processmessages;
        lies_lp; make_rest;
        label2.caption:=laenge(ltoa(getheapstatus.totalallocated DIV 1000),7,' ');
      END;
    END;
  END;
end;
{-----------------------------------------------------------}
procedure TlpForm.mnuBasis_lClick(Sender: TObject);
begin
  WITH lp_solver DO
  BEGIN
    opENDialog1.filename:='*.BSS'; stat_help_index:=15;
    IF opENDialog1.execute THEN
    IF POS('.BSS',ucase(opENDialog1.filename))<>0 THEN
    load_basis(opENDialog1.filename);
  END;
end;
{-----------------------------------------------------------}
procedure TlpForm.mnuTree_lClick(Sender: TObject);
begin
  WITH LpForm DO WITH lp_Solver DO IF stat_geladen THEN
  BEGIN
    mnu_solver_running;
    setfocus; keypreview:=TRUE;
    load_tree; keypreview:=FALSE;
    mnu_solver_stopped;
  END;
end;
{-----------------------------------------------------------}
procedure TlpForm.mnuCRLFClick(Sender: TObject);
VAR c:CHAR;
    fin,fout:TEXTFILE;
    f_,g_:STRIN;
BEGIN
  Opendialog1.filename:='*.MAT';
  IF opENDialog1.execute THEN WITH LpForm DO
  BEGIN
    f_:=ucase(opENDialog1.filename); g_:=COPY(f_,1,length(f_)-1);
    ASSIGNFILE(fin ,f_);  RESET(fin);
    ASSIGNFILE(fout,g_);  REWRITE(fout);
    WHILE NOT EOF(fin) DO
    BEGIN
      READ(fin,c);
      IF ORD(c)>13 THEN WRITE(fout,c) ELSE WRITELN(fout);
    END;
    CLOSEFILE(fin); CLOSEFILE(fout);
    assignFILE(fin,f_); erase(fin);
    assignFILE(fin,g_);
    rename(fin,f_);
    my_message('In file '+f_+' all LF have been replaced by CRLF');
  END;
end;
{-----------------------------------------------------------}
procedure TlpForm.mnuSolutionClick(Sender: TObject);
begin
  lp_solver.loesung;
end;
{-----------------------------------------------------------}
procedure TlpForm.mnuSolutionCSVClick(Sender: TObject);
begin
  lp_solver.loesung_csv;
end;
{-----------------------------------------------------------}
procedure TlpForm.mnuIntegerSolutionClick(Sender: TObject);
begin
  lp_solver.int_loesung;
end;
{-----------------------------------------------------------}
procedure TlpForm.mnuIntegerSolutionCSVClick(Sender: TObject);
begin
  lp_solver.int_loesung_csv;
end;
{-----------------------------------------------------------}
procedure TlpForm.mnuLP_sClick(Sender: TObject);
begin
  lp_solver.save_lp;
end;
{-----------------------------------------------------------}
procedure TlpForm.mnuMPSX_sClick(Sender: TObject);
begin
  lp_solver.save_mpsx;
end;
{-----------------------------------------------------------}
procedure TlpForm.mnuMPSXWithoutSpacesClick(Sender: TObject);
begin
  lp_solver.save_mpsx_without_spaces;
end;
{-----------------------------------------------------------}
procedure TlpForm.mnuBasis_sClick(Sender: TObject);
begin
  lp_solver.save_basis(TRUE);
end;
{-----------------------------------------------------------}
procedure TlpForm.mnuHelpAboutClick(Sender: TObject);
begin
IF application.helpjump('About') THEN;
end;
{-----------------------------------------------------------}
procedure TlpForm.on_close_query(Sender: TObject; var CanClose: Boolean);
begin
  IF MessageDlg('QUIT (Y/N) ',mtCustom,mbOkCancel,0)=mrok THEN
  BEGIN
    lp_solver.stat_abbruch:=TRUE; lp_solver.stat_user_abbruch:=TRUE;
    lp_solver.stat_quit:=TRUE; canclose:=TRUE;
  END
  ELSE canclose:=FALSE;
end;
END.

